#ifndef SP_LDLT
#define SP_LDLT
#include "sp_names.h"
#include SP_SMATRIX_H

class sp_LDLT
{ protected:
  sp_sMatrix A, F;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name;
  ls_REAL eps;
  int rc;
  sp_LDLT(char* ="sp_LDLT");
  sp_LDLT(sp_sMatrix &, ls_REAL =0., char* ="sp_LDLT");
  sp_LDLT(sp_LDLT &);
  unsigned char good()const{ return !rc;}
  sp_LDLT& swap(sp_LDLT &);
  const sp_LDLT& operator=(const sp_LDLT &);
  const sp_LDLT& solve(ls_Vector &, const ls_Vector &) const;
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_LDLT& write_row(ostream &) const;
  sp_LDLT& read_row(istream &);
  const sp_LDLT& write_column(ostream &) const;
  sp_LDLT& read_column(istream &);
  const sp_LDLT& operator>> (char *) const;
  sp_LDLT& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LDLT_C
#endif
#endif
