#ifndef SP_LU_COLUMN
#define SP_LU_COLUMN
#include "sp_names.h"
#include SP_MATRIX_H

class sp_LU_column
{ protected:
  sp_Matrix A, F;
  ls_array1<ls_UINT> irow, icol;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name, *irow_name, *icol_name;
  ls_REAL eps;
  int rc;
  sp_LU_column(char* ="sp_LU_column");
  sp_LU_column(sp_Matrix &, ls_REAL =0., char* ="sp_LU_column");
  sp_LU_column(sp_LU_column &);
  unsigned char good()const{ return !rc;}
  sp_LU_column& swap(sp_LU_column &);
  const sp_LU_column& operator=(const sp_LU_column &);
  const sp_LU_column& solve(ls_Vector &, const ls_Vector &) const;
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_LU_column& write_row(ostream &) const;
  sp_LU_column& read_row(istream &);
  const sp_LU_column& write_column(ostream &) const;
  sp_LU_column& read_column(istream &);
  const sp_LU_column& operator>> (char *) const;
  sp_LU_column& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LUCOLUMN_C
#endif
#endif
