#ifndef SP_LU_ROW
#define SP_LU_ROW
#include "sp_names.h"
#include SP_MATRIX_H

class sp_LU_row
{ protected:
  sp_Matrix A, F;
  ls_array1<ls_UINT> irow, icol;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  public:
  char *name, *A_name, *F_name, *irow_name, *icol_name;
  ls_REAL eps;
  int rc;
  sp_LU_row(char* ="sp_LU_row");
  sp_LU_row(sp_Matrix &, ls_REAL =0., char* ="sp_LU_row");
  sp_LU_row(sp_LU_row &);
  unsigned char good()const{ return !rc;}
  sp_LU_row& swap(sp_LU_row &);
  const sp_LU_row& operator=(const sp_LU_row &);
  const sp_LU_row& solve(ls_Vector &, const ls_Vector &) const;
  ls_UINT post_iteration(ls_Vector &, ls_Vector &) const;
  ls_Vector residuum(const ls_Vector &, const ls_Vector &) const;
  const sp_LU_row& write_row(ostream &) const;
  sp_LU_row& read_row(istream &);
  const sp_LU_row& write_column(ostream &) const;
  sp_LU_row& read_column(istream &);
  const sp_LU_row& operator>> (char *) const;
  sp_LU_row& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LUROW_C
#endif
#endif
