//: $CC -DSP_LIB -DLS_LIB -c $file $OPTIONS
#ifndef SP_VECTORC
#define SP_VECTORC
#include "sp_names.h"
#include SP_VECTOR_H

sp_Vector::sp_Vector(ls_UINT nn,char *nam):
eps(ls_EPS),sp_list1<ls_REAL>(nn,nam){}

sp_Vector::sp_Vector(sp_Vector &v):eps(ls_EPS),sp_list1<ls_REAL>(v){}

sp_Vector::sp_Vector(ls_REAL *v, ls_UINT l,char *nam):
eps(ls_EPS),sp_list1<ls_REAL>(v,l,nam){}

const sp_Vector& sp_Vector::operator=(const sp_Vector &v)
{ eps=v.eps; sp_list1<ls_REAL>::operator=(v); return *this;}

sp_Vector sp_Vector::operator-() const
{ sp_Vector y(a->i); ls_UINT l=0;
  list1<ls_REAL> const *aa=a;
  while((aa=aa->next)!=a) y.put(-aa->x, aa->i);
  return y;
}

sp_Vector sp_Vector::operator-(const sp_Vector &v) const
{ sp_Vector y; y=*this; y-=v; return y;}

sp_Vector sp_Vector::operator*(ls_REAL s) const
{ sp_Vector y; y=*this; y*=s; return y;}

ls_REAL sp_Vector::operator*(const sp_Vector &v) const// Skalarprodukt
{ static char *q1="sp_Vector::*";
  if(a->i!=v.dimension()) throw ls_error(v.name,q1,dimension_error_);
  list1<ls_REAL> *ap=a, *va=v.asList(), *vv=va, *aa;
  double s, sp=0, sm=0; ls_UINT i;
  while((vv=vv->next)!=va)
  { i=vv->i; while((aa=ap->next)->i<i) ap=aa;
    if(aa->i==i) if((s=vv->x*aa->x)>0) sp+=s; else sm+=s;
  }
  return ls_REAL(sp+sm);
}

sp_Vector& sp_Vector::operator*=(ls_REAL s)
{ list1<ls_REAL> *aa=a; while((aa=aa->next)!=a) aa->x*=s;
  return *this;
}

sp_Vector sp_Vector::operator+(const sp_Vector &v) const
{ sp_Vector y; y=*this; y+=v; return y;}

sp_Vector& sp_Vector::operator+=(const sp_Vector &v)
{ static char *q1="sp_Vector::+=";
  if(a->i!=v.dimension()) throw ls_error(v.name, q1, dimension_error_);
  list1<ls_REAL> *aa, *ap=a, *va=v.asList(), *vv=va;
  ls_UINT i;
  while((vv=vv->next)!=va)
  { i=vv->i; while((aa=ap->next)->i<i) ap=aa;
    if(aa->i==i)
    { if(ausl(aa->x,-(vv->x))>eps) aa->x+=vv->x;
      else{ ap->next=aa->next; ret1_el(aa);} continue;
    }
    ap=ap->next=get1_el(); ap->x=vv->x, ap->i=i, ap->next=aa;
  }
  return *this;
}

sp_Vector& sp_Vector::operator-=(const sp_Vector &v)
{ static char *q1="sp_Vector::-=";
  if(a->i!=v.dimension()) throw ls_error(v.name, q1, dimension_error_);
  list1<ls_REAL> *aa, *ap=a, *va=v.asList(), *vv=va;
  ls_UINT i;
  while((vv=vv->next)!=va)
  { i=vv->i; while((aa=ap->next)->i<i) ap=aa;
    if(aa->i==i)
    { if(ausl(aa->x,-(vv->x))>eps) aa->x-=vv->x;
      else{ ap->next=aa->next; ret1_el(aa);} continue;
    }
    ap=ap->next=get1_el(); ap->x=-vv->x, ap->i=i, ap->next=aa;
  }
  return *this;
}

sp_Vector operator*(ls_REAL s, const sp_Vector &x)
{ sp_Vector y; y=x; y*=s; return y;}
#endif
