//: $CC -c $file $OPTIONS
#ifndef SP_LIST1C
#define SP_LIST1C
#include "sp_names.h"
#include SP_LIST1_H

template <class T>
sp_list1<T>::sp_list1(ls_UINT l, char *nam):sp_list(1)
{ strcpy(name=ONAME,nam); a=get1_el(); a->i=l, a->x=0; a->next=a;}

template<class T>
sp_list1<T>::sp_list1(T *v, ls_UINT n, char *nam):sp_list(1)
{ static char *q1="sp_list1::sp_list1";
  strcpy(name=ONAME,nam);
  if(!n) throw ls_error(name,q1, size_error_);
  a=get1_el(); a->i=n, a->x=0; a->next=a;
  list1<T> *aa=a;
  for (ls_UINT i=0; i<n; i++)
    if(v[i]){ aa=aa->next=get1_el(); aa->x=v[i], aa->i=i;}
  aa->next=a;
}

template <class T>
sp_list1<T>::sp_list1(sp_list1<T> &v):sp_list(1)
{ strcpy(name=ONAME,v.name);
  list1<T> *aa=v.asList();
  a=get1_el(); a->i=aa->i, a->x=0, a->next=a;
  v.set_data(a); a=aa;
}

template<class T>
sp_list1<T>::~sp_list1()
{ list1<T> *aa;
  while((aa=a->next)!=a){ a->next=aa->next; ret1_el(aa);}
  ret1_el(a); --anz1;
}

template<class T>
sp_list1<T>& sp_list1<T>::swap(sp_list1<T> &v)
{ char na[ls_len]; strcpy(na,name); strcpy(name,v.name); strcpy(v.name,na);
  list1<T> *aa=v.asList();
  v.set_data(a); a=aa; return *this;
}

template<class T>
const sp_list1<T>& sp_list1<T>::operator=(const sp_list1<T> &v)
{ static char *q1="sp_list1::=";
  list1<T> *aa=a, *vv=v.asList(), *va=vv;
  if(a==vv) return *this;
  ls_UINT vdim=vv->i;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  if(a->i&&(a->i!=vdim)) throw ls_error(v.name, q1, dimension_error_);
  if(a->next!=a) remove(); a->i=vdim;
  while((vv=vv->next)!=va)
  { aa=aa->next=get1_el(); aa->x=vv->x, aa->i=vv->i;}
  aa->next=a; return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::put(T v, ls_UINT i)
{ static char *q1="sp_list1::put";
  if(!(i<a->i)) throw ls_error(name, q1, index_error_);
  list1<T> *aa, *ap=a;
  while((aa=ap->next)->i<i) ap=aa;
  if(aa->i==i)
  { if(!v){ ap->next=aa->next; ret1_el(aa);}
    else aa->x=v;
  }
  else if(v){ ap=ap->next=get1_el(); ap->next=aa, ap->i=i, ap->x=v;}
  return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::put_array(const sp_list1<T> &v, ls_UINT i)
{ static char *q1="sp_list1::put_array";
  if(!(i<a->i)) throw ls_error(name, q1, index_error_);
  ls_UINT vdim=v.dimension(), k, ll=(a->i-i<vdim)? a->i-i:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  list1<T> *vv=v.asList();
  for(k=0; k<ll; k++)
    if(vv->i==k) put(vv->x,i++), vv++; else put(0,i++);
  return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::put_array(const ls_array1<T> &v, ls_UINT i)
{ static char *q1="sp_list1::put_array";
  if(!(i<a->i)) throw ls_error(name,q1,index_error_);
  ls_UINT vdim=v.dimension(), ll=(a->i-i<vdim)? a->i-i:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  T *vv=v.asArray(), *ve=vv+ll;
  while(vv<ve) put(*vv,i++), vv++;
  return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::put_array(T s, ls_UINT i)
{ static char *q1="sp_list1::put_array";
  if(!(i<a->i)) throw ls_error(name,q1,index_error_);
  while(i<a->i) put(s,i++);
  return *this;
}

template<class T>
T sp_list1<T>::get(ls_UINT i) const
{ static char *q1="sp_list1::get";
  if(!(i<a->i)) throw ls_error(name, q1, index_error_);
  list1<T> *aa=a;
  while((aa=aa->next)->i<i);
  if(aa->i==i) return aa->x;
  return 0;
}

template<class T>
const sp_list1<T>& sp_list1<T>::get_array(sp_list1<T> &v, ls_UINT i) const
{ static char *q1="sp_list1::get_array";
  if(!(i<a->i)) throw ls_error(name, q1, index_error_);
  ls_UINT vdim=v.dimension(), k, ll=(a->i-i<vdim)? a->i-i:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  list1<T> *aa=a;
  while((aa=aa->next)->i<i);
  for(k=0; k<ll; k++)
    if(aa->i==i+k) v.put(aa->x,k), aa=aa->next; else v.put(0,k);
  return *this;
}

template<class T>
const sp_list1<T>& sp_list1<T>::get_array(ls_array1<T> &v, ls_UINT i) const
{ static char *q1="sp_list1::get_array";
  if(!(i<a->i)) throw ls_error(name, q1, index_error_);
  ls_UINT vdim=v.dimension(), k, ll=(a->i-i<vdim)? a->i-i:vdim;
  if(!vdim) throw ls_error(v.name,q1,object_is_empty_);
  list1<T> *aa=a; T *vv=v.asArray();
  while((aa=aa->next)->i<i);
  for(k=0; k<ll; k++, vv++)
    if(aa->i==i+k) *vv=aa->x, aa=aa->next; else *vv=0;
  return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::append(ls_UINT l)
{ ls_UINT n=a->i; a->i+=l; return *this;}

template<class T>
sp_list1<T>& sp_list1<T>::remove(ls_UINT i)
{ static char *q1="sp_list1::remove";
  if(!(i<a->i)) throw ls_error(name, q1, index_error_);
  list1<T> *ap=a, *aa;
  while((aa=ap->next)->i<i) ap=aa;
  if(aa->i==i){ ap->next=aa->next; ret1_el(aa);}
  while((ap=ap->next)!=a) ap->i-=1;
  a->i-=1; return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::remove()
{ if(a->next!=a)
  { list1<T> *aa;
    while((aa=a->next)!=a){ a->next=aa->next; ret1_el(aa);}
  }
  a->i=0; return *this;
}

template<class T>
const sp_list1<T>& sp_list1<T>::write(ostream &f) const
{ static char *q1="sp_list1::write";
  ls_UINT l=0; list1<T> *aa=a;
  if(a->next==a) throw ls_error(q1,name,object_is_empty_);
  while((aa=aa->next)!=a) l++;
  f<<name<<endl;
  f<<"{ "<<dimension_<<" "<<a->i<<" "<<number_of_elements_<<" "<<l<<endl;
  aa=a;
  while((aa=aa->next)!=a) f<<" "<<aa->i<<" "<<aa->x; f<<endl<<"}"<<endl;
  return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::read(istream &f)
{ static char *q1="sp_list1::read";
  if(a->next!=a) throw ls_error(name, q1, object_not_empty_);
  char w[ls_len];
  list1<T> *aa;
  ls_UINT l;
  if(*name)while(f>>w&&strcmp(w,name));else f>>name;
  if(!f.good()) throw ls_error(name, q1, object_not_found_);
  f>>w;
  if(strcmp(w, "{")) throw ls_error(name,q1,object_contents_error_);
  if(!(f>>w)||strcmp(w, dimension_)||!(f>>a->i))
    throw ls_error(name, q1, object_contents_error_);
  if(!(f>>w)||strcmp(w, number_of_elements_)||!(f>>l))
    throw ls_error(name, q1, object_contents_error_);
  aa=a;
  while(l--){ aa=aa->next=get1_el(); f>>aa->i, f>>aa->x;}
  aa->next=a;
  if(!(f>>w)||(*w!='}')) throw ls_error(name, q1, object_end_error_);
  return *this;
}

template<class T>
const sp_list1<T>& sp_list1<T>::operator>> (char *nam) const
{ if(!*nam)
  { cout.setf(ios::fixed, ios::floatfield);
    cout.precision(int(sizeof(ls_REAL)*1.5));
    write(cout);
  }
  else
  { ofstream f(nam);
    f.setf(ios::scientific, ios::floatfield);
    f.precision(int(sizeof(ls_REAL)*1.5));
    write(f);
  }
  return *this;
}

template<class T>
sp_list1<T>& sp_list1<T>::operator<< (char *nam)
{ if(!*nam) read(cin); else{ ifstream f(nam); read(f);}
  return *this;
}
#endif
