#ifndef SP_LIST2
#define SP_LIST2
#include <string.h>
#include "sp_names.h"
#include LS_ARRAY2_H
#include SP_LIST1_H

template<class T>
class sp_list2: public sp_list<T>
{ protected:
  list2<T>  *a; // a->i=m; a->j=n; a->r_next=a->c_next=b;
                // b+i : Anker der i-ten Zeile und i-ten Spalte
                // (b+i)->r_next : 1. Datenelement der i-ten Zeile;
                // (b+i)->c_next : 1. Datenelement der i-ten Spalte;
                // (b+i)->i : Element-Anzahl der i-ten Zeile;
                // (b+i)->j : Element-Anzahl der i-ten Spalte;
                // das letzte r_next bzw. c_next zeigt auf a;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  void set_data(list2<T> *aa){ a=aa;}
  public:
  char *name;
  sp_list2(ls_UINT =0, ls_UINT =0, char* ="sp_list2");
  sp_list2(sp_list2<T> &);
  sp_list2(T*, ls_UINT, ls_UINT, char* ="sp_list2");
  ~sp_list2();
  sp_list2<T>& swap(sp_list2<T> &);
  ls_UINT number_of_rows() const{ return a->i; }
  ls_UINT number_of_columns() const{ return a->j;}
  list2<T>* asList()const{ return a;}
  const sp_list2<T>& operator=(const sp_list2<T> &);
  sp_list2<T>& put(T, ls_UINT, ls_UINT);
  sp_list2<T>& put_row(const sp_list1<T> &, ls_UINT, ls_UINT =0);
  sp_list2<T>& put_row(const ls_array1<T> &, ls_UINT, ls_UINT =0);
  sp_list2<T>& put_row(T, ls_UINT, ls_UINT =0);
  sp_list2<T>& put_column(const sp_list1<T>&, ls_UINT, ls_UINT);
  sp_list2<T>& put_column(const ls_array1<T>&, ls_UINT, ls_UINT);
  sp_list2<T>& put_column(T, ls_UINT, ls_UINT);
  sp_list2<T>& put_diagonal(const sp_list1<T> &, ls_UINT =0, ls_UINT =0);
  sp_list2<T>& put_diagonal(const ls_array1<T> &, ls_UINT =0, ls_UINT =0);
  sp_list2<T>& put_diagonal(T, ls_UINT =0, ls_UINT =0);
  sp_list2<T>& put_array(const sp_list2<T> &, ls_UINT =0, ls_UINT =0);
  sp_list2<T>& put_array(const ls_array2<T> &, ls_UINT =0, ls_UINT =0);
  sp_list2<T>& put_array(T, ls_UINT =0, ls_UINT =0);
  T get(ls_UINT, ls_UINT) const;
  const sp_list2<T>& get_row(sp_list1<T> &,ls_UINT, ls_UINT =0) const;
  const sp_list2<T>& get_row(ls_array1<T> &,ls_UINT, ls_UINT =0) const;
  const sp_list2<T>& get_column(sp_list1<T> &,ls_UINT, ls_UINT) const;
  const sp_list2<T>& get_column(ls_array1<T> &,ls_UINT, ls_UINT) const;
  const sp_list2<T>& get_diagonal(sp_list1<T> &,ls_UINT =0, ls_UINT =0) const;
  const sp_list2<T>& get_diagonal(ls_array1<T> &,ls_UINT =0, ls_UINT =0) const;
  const sp_list2<T>& get_array(sp_list2<T>&, ls_UINT =0, ls_UINT =0) const;
  const sp_list2<T>& get_array(ls_array2<T>&, ls_UINT =0, ls_UINT =0) const;
  sp_list2<T>& append_row(ls_UINT =1);
  sp_list2<T>& append_column(ls_UINT =1);
  sp_list2<T>& append_array(ls_UINT =1, ls_UINT =1);
  sp_list2<T>& remove_row(ls_UINT);
  sp_list2<T>& remove_column(ls_UINT);
  sp_list2<T>& remove();
  sp_list2<T>& swap_row(ls_UINT, ls_UINT);
  sp_list2<T>& swap_column(ls_UINT, ls_UINT);
  const sp_list2<T>& write_row(ostream &) const;
  sp_list2<T>& read_row(istream &);
  const sp_list2<T>& write_column(ostream &) const;
  sp_list2<T>& read_column(istream &);
  const sp_list2<T>& operator>> (char *) const;
  sp_list2<T>& operator<< (char *);
  ls_REAL filling_density();
};
#ifndef SP_LIB
#include SP_LIST2_C
#endif
#endif
