#ifndef SP_LISTU
#define SP_LISTU
#include "sp_names.h"
#include LS_ARRAYU_H
#include SP_LIST2_H

template<class T>
class sp_listU: public sp_list<T>
{ protected:
  list2<T> *a;// a->i=n; a->j=n; a->r_next=a->c_next=b oder a;
              // b+i Anker der i-ten Zeile und i-ten Spalte
              // (b+i)->r_next 1. Datenelement der i-ten Zeile;
              // (b+i)->c_next 1. Datenelement der i-ten Spalte;
              // (b+i)->i Element-Anzahl der i-ten Zeile;
              // (b+i)->j Element-Anzahl der i-ten Spalte;
              // das letzte r_next bzw. c_next zeigt auf a;
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  void set_data(list2<T> *aa){ a=aa;}
  public:
  char *name;
  sp_listU(ls_UINT =0, char* ="sp_listU");
  sp_listU(sp_listU<T> &);
  ~sp_listU();
  sp_listU<T>& swap(sp_listU<T>&);
  ls_UINT dimension() const{ return a->i;}
  ls_REAL filling_density();
  const sp_listU<T>& operator=(const sp_listU<T>&);
  list2<T>* asList() const{ return a;}
  sp_listU<T>& put(T, ls_UINT, ls_UINT);
  sp_listU<T>& put_row(const sp_list1<T>&, ls_UINT, ls_UINT =0);
  sp_listU<T>& put_row(const ls_array1<T>&, ls_UINT, ls_UINT =0);
  sp_listU<T>& put_row(T, ls_UINT, ls_UINT =0);
  sp_listU<T>& put_diagonal(const sp_list1<T>&, ls_UINT, ls_UINT);
  sp_listU<T>& put_diagonal(const ls_array1<T>&, ls_UINT, ls_UINT);
  sp_listU<T>& put_diagonal(T, ls_UINT =0, ls_UINT =0);
  sp_listU<T>& put_array(const sp_listU<T>&, ls_UINT =0, ls_UINT =0);
  sp_listU<T>& put_array(const ls_arrayU<T>&, ls_UINT =0, ls_UINT =0);
  T get(ls_UINT, ls_UINT) const;
  const sp_listU<T>& get_row(sp_list1<T>&, ls_UINT, ls_UINT =0) const;
  const sp_listU<T>& get_row(ls_array1<T>&, ls_UINT, ls_UINT =0) const;
  const sp_listU<T>& get_diagonal(sp_list1<T>&, ls_UINT, ls_UINT) const;
  const sp_listU<T>& get_diagonal(ls_array1<T>&, ls_UINT, ls_UINT) const;
  const sp_listU<T>& get_array(sp_listU<T> &, ls_UINT =0, ls_UINT =0) const;
  const sp_listU<T>& get_array(ls_arrayU<T>&, ls_UINT =0, ls_UINT =0) const;
  sp_listU<T>& append_row(ls_UINT =1);
  sp_listU<T>& swap_row(ls_UINT, ls_UINT);
  sp_listU<T>& remove_row(ls_UINT);
  sp_listU<T>& remove();
  const sp_listU<T>& write_row(ostream &) const ;
  sp_listU<T>& read_row(istream &);
  const sp_listU<T>& write_column(ostream &) const ;
  sp_listU<T>& read_column(istream &);
  const sp_listU<T>& operator>> (char *) const ;
  sp_listU<T>& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LISTU_C
#endif
#endif
