#ifndef SP_SMATRIX
#define SP_SMATRIX
#include "sp_names.h"
#include SP_MATRIX_H
#include LS_SMATRIX_H
#include SP_LISTU_H

class sp_sMatrix: public sp_listU<ls_REAL>
{ public:
  sp_sMatrix(ls_UINT n=0,char *nam="sp_sMatrix"):
  sp_listU<ls_REAL>(n,nam){}
  sp_sMatrix(sp_sMatrix &B):sp_listU<ls_REAL>(B){}
  ls_Vector row(ls_UINT i)const
  { ls_Vector u(a->i); get_row(u,i); return u;}
  ls_Vector diagonal(ls_UINT i)const
  { ls_Vector u(a->i); get_diagonal(u,0,i); return u;}
  const sp_sMatrix& operator=(const sp_sMatrix &);
  sp_sMatrix operator+(const sp_sMatrix &)const;   //A+B
  sp_sMatrix operator-(const sp_sMatrix &)const;   //A-B
  sp_sMatrix& operator+=(const sp_sMatrix &);      //A=A+B
  sp_sMatrix& operator-=(const sp_sMatrix &);      //A=A-B
  sp_Matrix operator*(const sp_sMatrix &)const;    //A*B
  sp_Vector operator* (const sp_Vector &) const;
  ls_Vector operator* (const ls_Vector &) const;
  ls_UINT solve(ls_Vector &, ls_Vector &) const;
};
#ifndef SP_LIB
#include SP_SMATRIX_C
#endif
#endif
